# Ajuste no lineal de elipses
# usando Levenberg-Marquardt
# de scipy

import sys
import numpy as np
import portogonal
from scipy.optimize import least_squares
import math
import pprime

# La elipse inicial la pasamos en la línea de comandos
n = len( sys.argv )
if n != 6 :
	print( "Args: Xc Yc a b alpha" )
	sys.exit(1)

pXc = float( sys.argv[1] )
pYc = float( sys.argv[2] )
pa = float( sys.argv[3] )
pb = float( sys.argv[4] )
palpha = float( sys.argv[5] )

va = np.array( [ pXc, pYc, pa, pb, palpha ] )
print( va.shape )
print( va )

# Leer los puntos de entrada de un archivo
Pi = np.loadtxt( "puntos.txt" )
print( Pi.shape )
# Pi es una matrix de tamaño  n x 2
n, m = Pi.shape

# Los puntos de entrada se transforman
# hacia la elipse en el origen
# pi es una matrix de tamaño  n x 2
pi = np.zeros( (n, 2 ) )  # Los puntos de entrada en el sistema de coordenadas
                          # centrado en la elipse en el origen.

ppi = np.zeros( (n, 2 ) ) # Los puntos sobre la elipse

# El Newton para resolver el ajuste de la elipse
def myfunc( myva ) :
	Xc = myva[0]
	Yc = myva[1]
	a = myva[2]
	b = myva[3]

	alpha = myva[4]

	c = math.cos( alpha )
	s = math.sin( alpha )

	j = 0
	while j < n :
		x = Pi[j,0] - Xc
		y = Pi[j,1] - Yc
		pi[j,0] =  c*x + s*y
		pi[j,1] = -s*x + c*y
		j += 1

	# Calculamos los puntos sobre la elipse
	j = 0
	while j < n :
		ppi[j:] = portogonal.punto_ortogonal( a, b, pi[j,0], pi[j,1] )
		j += 1

	verror = np.zeros( (2*n, ) )
	j = 0
	while j < n :
		x = ppi[j,0]
		y = ppi[j,1]

		X = c*x - s*y + Xc
		Y = s*x + c*y + Yc

		verror[ 2*j ] = Pi[j,0] - X
		verror[ 2*j+1 ] = Pi[j,1] - Y
		
		j += 1

	return verror


vresult = least_squares( myfunc, va, gtol=1e-12, xtol=1e-12, ftol=1e-12, method='lm' )
# vresult = least_squares( myfunc, va, gtol=1e-12, xtol=1e-12, ftol=1e-12, method='trf' )

print( "Resultado:" )
print( vresult )
