import math

def f( t, a, b, x, y ) :
	c = math.cos(t)
	s = math.sin(t)
	cte = a*a - b*b
	v = cte*s*c - x*a*s + y*b*c
	return v

def df( t, a, b, x, y ) :
	c = math.cos(t)
	s = math.sin(t)
	# [cte*sin(t)]*cos(t) - x*a*sin(t) + y*b*cos(t) = 0

	cte = a*a - b*b
	v = - cte*s*s + cte*c*c - x*a*c - y*b*s
	return v

def punto_ortogonal( a, b, x, y ) :
	# Del paper:
	#
	#
	k = (a*b)/math.sqrt( b*b*x*x + a*a*y*y )
	k1x = x*k
	k1y = y*k
	
	if math.fabs(x) < a :
		k2x = x
		if y >= 0.0 :
			k2y = (b/a)*math.sqrt(a*a - x*x)
		else :
			k2y = -(b/a)*math.sqrt(a*a - x*x)
	else :
		if x >= 0 :
			k2x = a
		else :
			k2x = -a
	
		k2y = 0.0
	
	k0x = (k1x  + k2x)/2.0
	k0y = (k1y  + k2y)/2.0

	# El valor de t inicial para el Newton	
	t = math.atan2( k0y, k0x )

	# El método de Newton	
	i=0
	while i < 20 :
		Deltat = -f(t, a, b, x, y)/df(t, a, b, x, y)
	
		if math.fabs( Deltat ) < 1e-10 :
			break

		t += Deltat

		# print( i, t )

		i += 1

	return( a*math.cos(t), b*math.sin(t) )
